@using Services;
@inject ConvertService convertService

<div class="input-group">
    <div class="input-group-prepend">
        <div class="input-group-text">
            <input type="checkbox" value="@Enabled" @onchange="((ChangeEventArgs __e) => SetEnabled(__e?.Value))" />
        </div>
    </div>
    <input class="form-control form-control-sm mr-sm-2"
           value="@DisplayValue" @oninput="((ChangeEventArgs __e) => SetValue(__e?.Value))"
           onClick="this.select();"
            @onfocus="() => SetFocusChanged(true)" @onblur="() => SetFocusChanged(false)"
           disabled="@(!Enabled)" maxlength="@MaxLength" />
</div>

@code {
    [Parameter]
    public double MaxLength { get; set; } = 12;

    [Parameter]
    public double Value { get; set; }

    [Parameter]
    public EventCallback<double> ValueChanged { get; set; }

    [Parameter]
    public bool Enabled { get; set; }

    [Parameter]
    public EventCallback<bool> EnabledChanged { get; set; }

    [Parameter]
    public bool EnableCurrencyConvert { get; set; } = true;

    public string DisplayValue { get; set; }
    public bool IsInFocus { get; set; }

    protected override void OnParametersSet()
    {
        UpdateDisplayValue();
    }

    private void SetValue(object value)
    {
        if (Enabled)
        {
            Value = convertService.ToDouble(value);
            if (Value < 0) Value = 0;
            UpdateDisplayValue();
            ValueChanged.InvokeAsync(Value);
        }
    }

    private void SetEnabled(object value)
    {
        Enabled = Convert.ToBoolean(value);
        EnabledChanged.InvokeAsync(Enabled);
    }

    private void SetFocusChanged(bool inFocus)
    {
        IsInFocus = inFocus;
        UpdateDisplayValue();
    }

    private void UpdateDisplayValue()
    {
        if ((EnableCurrencyConvert == false) || IsInFocus) DisplayValue = Value.ToString();
        else DisplayValue = convertService.ToIndianCurrency(Value, false, false);
    }

}
